From ad3a2aabe4210e333ba5d3fee4c66877001ba033 Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sat, 2 Dec 2023 01:37:35 +0100
Subject: [PATCH 37/54] feat: frame around plain gtk gpu stats section

---
 .../root_stack/oc_page/gpu_stats_section.rs   |  3 +-
 lact-gui/ui/oc_page/gpu_stats_section.blp     |  4 -
 lact-gui/ui/oc_page/gpu_stats_section_gtk.blp | 97 +++++++++++++++++++
 3 files changed, 99 insertions(+), 5 deletions(-)
 create mode 100644 lact-gui/ui/oc_page/gpu_stats_section_gtk.blp

diff --git a/lact-gui/src/app/root_stack/oc_page/gpu_stats_section.rs b/lact-gui/src/app/root_stack/oc_page/gpu_stats_section.rs
index 2093fbef..8653d599 100644
--- a/lact-gui/src/app/root_stack/oc_page/gpu_stats_section.rs
+++ b/lact-gui/src/app/root_stack/oc_page/gpu_stats_section.rs
@@ -84,7 +84,8 @@ mod imp {
 
     #[derive(CompositeTemplate, Default, Properties)]
     #[properties(wrapper_type = super::GpuStatsSection)]
-    #[template(file = "ui/oc_page/gpu_stats_section.blp")]
+    #[cfg_attr(feature = "libadwaita", template(file = "ui/oc_page/gpu_stats_section.blp"))]
+    #[cfg_attr(not(feature = "libadwaita"), template(file = "ui/oc_page/gpu_stats_section_gtk.blp"))]
     pub struct GpuStatsSection {
         #[property(get, set)]
         core_clock: RefCell<String>,
diff --git a/lact-gui/ui/oc_page/gpu_stats_section.blp b/lact-gui/ui/oc_page/gpu_stats_section.blp
index 6253af34..023ecaad 100644
--- a/lact-gui/ui/oc_page/gpu_stats_section.blp
+++ b/lact-gui/ui/oc_page/gpu_stats_section.blp
@@ -70,10 +70,6 @@ template $GpuStatsSection: $PageSection {
                 }
             }
 
-            //Separator {
-            //    orientation: vertical;
-            //}
-
             Box {
                 orientation: vertical;
                 hexpand: true;
diff --git a/lact-gui/ui/oc_page/gpu_stats_section_gtk.blp b/lact-gui/ui/oc_page/gpu_stats_section_gtk.blp
new file mode 100644
index 00000000..4d78a1d4
--- /dev/null
+++ b/lact-gui/ui/oc_page/gpu_stats_section_gtk.blp
@@ -0,0 +1,97 @@
+using Gtk 4.0;
+using Adw 1;
+
+template $GpuStatsSection: $PageSection {
+    name: "GPU statistics";
+    spacing: 12;
+
+    Frame {
+        styles ["view"]
+        Box {
+            orientation: vertical;
+            spacing: 12;
+
+            Box {
+                orientation: vertical;
+                margin-top: 12;
+                margin-start: 12;
+                margin-end: 12;
+                spacing: 6;
+
+                Label {
+                    label: "VRAM Usage";
+                    xalign: 0.0;
+                }
+
+                Overlay {
+                    LevelBar vram_usage_bar {
+                        hexpand: true;
+                        height-request: 18;
+                        value: bind template.vram-usage;
+                        orientation: horizontal;
+                    }
+
+                    [overlay]
+                    Label vram_usage_label {
+                        label: bind template.vram-usage-text;
+                    }
+                }
+            }
+
+            Separator {
+                orientation: horizontal;
+            }
+
+            Box {
+                orientation: horizontal;
+                margin-bottom: 12;
+                margin-start: 12;
+                margin-end: 12;
+                homogeneous: true;
+                spacing: 12;
+
+                Box {
+                    orientation: vertical;
+                    hexpand: true;
+                    spacing: 6;
+
+                    $InfoRow {
+                        name: "Core Clock:";
+                        value: bind template.core-clock;
+                    }
+
+                    $InfoRow {
+                        name: "Voltage:";
+                        value: bind template.voltage;
+                    }
+
+                    $InfoRow {
+                        name: "Temp (hotspot):";
+                        value: bind template.temperature;
+                    }
+                }
+
+                Box {
+                    orientation: vertical;
+                    hexpand: true;
+                    spacing: 6;
+
+                    $InfoRow {
+                        name: "Memory Clock:";
+                        value: bind template.vram-clock;
+                    }
+
+                    $InfoRow {
+                        name: "Usage:";
+                        value: bind template.gpu-usage;
+                    }
+
+                    $InfoRow {
+                        name: "Power Usage:";
+                        value: bind template.power-usage;
+                    }
+                }
+            }
+        }
+    }
+}

